﻿#version 120

attribute vec3 vPosition;
attribute vec3 vColor;
attribute vec3 vNormal;
attribute float vAlpha;

varying vec4 color;

uniform mat4 projection;
uniform mat4 model;
uniform mat4 view;

uniform float lit;

const float lightaway = 1000;
const float kd = 0.9;
 
void main()
{
	gl_Position = projection * view * model * vec4(vPosition, 1.0);
	color = vec4(vColor[0], vColor[1], vColor[2], vAlpha);

	if (vAlpha < 0.001)
	{
		gl_Position = vec4(1E9, 1E9, 1E9, 0); 
	}

    if (lit > 0.5)
	{
		vec3 eyepos = -lightaway * view[3][3] * vec3(view[0][2],view[1][2],view[2][2]);
		vec3 worldpos = mat3(model) * vPosition;
		vec3 V = normalize( eyepos - worldpos);

		vec3 worldnorm1 = normalize(mat3(model) * vNormal);
		vec3 worldnorm2 = normalize(mat3(model) * -vNormal);

		float diffuse1 = kd * max(0, dot(V,worldnorm1));
		float diffuse2 = kd * max(0, dot(V,worldnorm2));

		float edgeDetection = 0;
		float light = 0;

		if (diffuse2 > diffuse1)
		{
			//edgeDetection = (dot(V, worldnorm2) > 0.2) ? 1 : 0;
			//light = edgeDetection * diffuse2;	
			light = diffuse2;	
		}
		else
		{
			//edgeDetection = (dot(V, worldnorm1) > 0.2) ? 1 : 0;
			//light = edgeDetection * diffuse1;	
			light = diffuse1;
		}

		color = vec4( light*color[0], light*color[1], light*color[2], vAlpha);
	}
}